spat<-80
n<-500
nP<-150
nloop<-200

library(circular)
library(igraph)
library(wordspace)

x1<-5
x2<-5
x3<-2.5
x4<-3.5
x5<-0.5
x6<-0.5
x7<-0.75
x8<-0.05
x9<-1

inds<-array(data=0, dim=c(n,15))
colnames(inds)<-c("alarm","xloc","yloc","birth","death","feeding","r_rep","r_det","orientation", "torus_x1","torus_y1", "torus_x2","torus_y2", "torus_x3","torus_y3")
rownames(inds)<-as.factor(c(1:n))
inds[,2]<-sample(x=0:spat,size=dim(inds)[1],replace=TRUE)
inds[,3]<-sample(x=0:spat,size=dim(inds)[1],replace=TRUE)
inds[,7]<-x9
inds[,8]<-x3
orientation<-rep(NA,n)
suppressWarnings(for(i in 1:n) {orientation[i]<-rwrappedcauchy(1,mu=0,rho=.8)})
inds[,9]<-orientation
inds[,10]<-Inf
inds[,11]<-Inf
inds[,12]<-Inf
inds[,13]<-Inf
inds[,14]<-Inf
inds[,15]<-Inf

preds<-array(data=0,dim=c(nP,15))
colnames(preds)<-c("alarm","xloc","yloc","birth","death","feeding","r_rep","r_det","orientation","torus_x1","torus_y1", "torus_x2","torus_y2", "torus_x3","torus_y3")
rownames(preds)<-as.factor(c(1:nP))
preds[,2]<-sample(x=0:spat,size=dim(preds)[1],replace=TRUE)
preds[,3]<-sample(x=0:spat,size=dim(preds)[1],replace=TRUE)
preds[,7]<-x9
preds[,8]<-x4
orientation<-rep(NA,nP)
suppressWarnings(for(j in 1:nP) {orientation[j]<-rwrappedcauchy(1,mu=0,rho=.8)})
preds[,9]<-orientation
preds[,10]<-Inf
preds[,11]<-Inf
preds[,12]<-Inf
preds[,13]<-Inf
preds[,14]<-Inf
preds[,15]<-Inf
      
ts<-0
time_steps<- nloop
inds_hist<-NULL
preds_hist<-NULL
while(ts < time_steps){
         inds<-movement1_torus(inds,x1)
         inds<-death_c(inds,x9)
         preds<-movement2_torus(preds,x2)
         preds<-death_c(preds,x9)
         inds<-check_pred(inds,preds,x3,x5)
         dem_net<-dem_network(inds,x3)
         inds<-isi_use(dem_net,inds,k=2,x6)
         inds<-feeding(inds)
         hunt_list<-hunt_prey(inds,preds,x4)
         inds<-hunt_list[[1]]
         preds<-hunt_list[[2]]
         inds<-inds[inds[,5]==0,]
         if(!is.array(inds) || dim(inds)[1]==0) {break}
         inds<-ind_death_birth3(inds,x7,x3)
         inds<-death_c(inds,x9)
         preds<-pred_death_birth3(preds,x8,x4)
         preds<-death_c(preds,x9)
         ts<-ts+1
         inds_hist[[ts]]<-inds
         preds_hist[[ts]]<-preds
}