torus_add<-function(agents,radius){
    for (i in 1:dim(agents)[1]){
         if(agents[i,2]<=radius) {agents[i,10]<-spat+agents[i,2]; agents[i,11]<-agents[i,3]}
         if(agents[i,3]<=radius) {agents[i,13]<-spat+agents[i,3]; agents[i,12]<-agents[i,2]}
         if(agents[i,2]>=spat-radius) {agents[i,10]<-0-(spat-agents[i,2]); agents[i,11]<-agents[i,3]}
         if(agents[i,3]>=spat-radius) {agents[i,13]<-0-(spat-agents[i,3]); agents[i,12]<-agents[i,2]}
         if(agents[i,2]<=radius & agents[i,3]<=radius)  {agents[i,14]<-spat+agents[i,2]; agents[i,15]<-spat+agents[i,3]}
         if(agents[i,2]>=spat-radius & agents[i,3]>=spat-radius) {agents[i,14]<-0-(spat-agents[i,2]); agents[i,15]<-0-(spat-agents[i,3])}
         if(agents[i,2]<=radius & agents[i,3]>=spat-radius)  {agents[i,14]<-spat+agents[i,2]; ; agents[i,15]<-0-(spat-agents[i,3])}
         if(agents[i,2]>=spat-radius & agents[i,3]<=radius)  {agents[i,14]<-0-(spat-agents[i,2]); agents[i,15]<-spat+agents[i,3]}
    }
return(agents)
}

movement1_torus<-function(inds, x1){
  total_inds<-dim(inds)[1]
  move_dists<-seq(0,x1,by=1)
  angles<-rep(NA,total_inds)
  suppressWarnings(for(i in 1:total_inds) {angles[i]<-rwrappedcauchy(1,mu=0,rho=.8)})
  phi<-inds[, 9]+angles;

  x_move<-sample(x=move_dists, size=total_inds, replace=TRUE)*(cos(phi))
  y_move<-sample(x=move_dists, size=total_inds, replace=TRUE)*(sin(phi))
  inds[,2]<-inds[,2]+x_move
  inds[,3]<-inds[,3]+y_move
  inds[,9]<-phi

  for(i in 1:total_inds){
    if(inds[i,2]>spat){
      dist_over<-inds[i,2]-spat
      inds[i,2]<-0+dist_over      
    }
    if(inds[i,2]<0){
      dist_over<-inds[i, 2]
      inds[i, 2]<-spat+dist_over
    }
    if(inds[i,3]>spat){
      dist_over<-inds[i,3]-spat
      inds[i,3]<-0+dist_over
    }
    if(inds[i,3]<0){
      dist_over<-inds[i,3]
      inds[i,3]<-spat+dist_over
    }
  } 
  inds<-torus_add(inds,5)
  return(inds)
}

movement2_torus<-function(preds, x2){
  total_preds<-dim(preds)[1]
  move_dists<-seq(0,x2,by=1)
  angles<-rep(NA,total_preds)
  suppressWarnings(for(i in 1:total_preds) {angles[i]<-rwrappedcauchy(1,mu=0,rho=.8)})
  phi<-preds[,9]+angles

  x_move<-sample(x=move_dists, size=total_preds, replace=TRUE)*(cos(phi))
  y_move<-sample(x=move_dists, size=total_preds, replace=TRUE)*(sin(phi))
  preds[,2]<-preds[,2]+x_move
  preds[,3]<-preds[,3]+y_move
  preds[,9]<-phi

  for(i in 1:total_preds){
    if(preds[i,2]>spat){
      dist_over<-preds[i,2]-spat
      preds[i,2]<-0+dist_over
    }
    if(preds[i,2]<0){
      dist_over<-preds[i,2]
      preds[i, 2]<-spat+dist_over
    }
    if(preds[i,3]>spat){
      dist_over<-preds[i,3]-spat
      preds[i,3]<-0+dist_over
    }
    if(preds[i,3]<0){
      dist_over<-preds[i,3]
      preds[i,3]<-spat+dist_over
    }
  }
  preds<-torus_add(preds,5)
  return(preds)
}

death_c <- function(inds,x9){
  dist_mat0<-as.matrix(dist.matrix(cbind(inds[,2], inds[,3]),method="euclidean"),diag=T,upper=T) 
  dist_mat1<-as.matrix(dist.matrix(cbind(ifelse(inds[,10]!=Inf,inds[,10],inds[,2]), ifelse(inds[,11]!=Inf,inds[,11],inds[,3])),method="euclidean"),diag=T,upper=T)
  dist_mat2<-as.matrix(dist.matrix(cbind(ifelse(inds[,12]!=Inf,inds[,12],inds[,2]), ifelse(inds[,13]!=Inf,inds[,13],inds[,3])),method="euclidean"),diag=T,upper=T)
  dist_mat3<-as.matrix(dist.matrix(cbind(ifelse(inds[,14]!=Inf,inds[,14],inds[,2]), ifelse(inds[,15]!=Inf,inds[,15],inds[,3])),method="euclidean"),diag=T,upper=T)

  tmp0<-ifelse(dist_mat0<=x9,1,0)
  tmp1<-ifelse(dist_mat1<=x9,1,0)
  tmp2<-ifelse(dist_mat2<=x9,1,0)
  tmp3<-ifelse(dist_mat3<=x9,1,0)

  tmp<-tmp0+tmp1+tmp2+tmp3
  diag(tmp)<-0
  tmp_bin<-ifelse(tmp>0,1,0)
  g<-graph.adjacency(tmp_bin)
  cl<-components(g)
  competitors_list<-lapply(seq_along(cl$csize)[cl$csize > 1], function(x) V(g)$name[cl$membership %in% x])
  if(length(competitors_list)==0) {return(inds)} else {
  rand_competitors<-NULL
  for (i in 1:length(competitors_list)){
     rand_competitors[[i]]<-sample(competitors_list[[i]],length(competitors_list[[i]])-1)
  }
  rand_competitors<-as.numeric(unlist(rand_competitors))
  inds[rownames(inds) %in% rand_competitors,5]<-1
  inds <- inds[inds[,5] == 0,]
  return(inds)}
}

check_pred<-function(inds, preds, x3, x5){
  for (j in 1:dim(inds)[1]){
    for (i in 1:dim(preds)[1]){
      if(sqrt((preds[i,2]-inds[j,2])^2+(preds[i,3]-inds[j,3])^2)<=x3)  {inds[j,1]<-rbinom(1,1,x5)}
      if(sqrt((preds[i,10]-inds[j,2])^2+(preds[i,11]-inds[j,3])^2)<=x3)  {inds[j,1]<-rbinom(1,1,x5)}
      if(sqrt((preds[i,12]-inds[j,2])^2+(preds[i,13]-inds[j,3])^2)<=x3)  {inds[j,1]<-rbinom(1,1,x5)}
      if(sqrt((preds[i,14]-inds[j,2])^2+(preds[i,15]-inds[j,3])^2)<=x3)  {inds[j,1]<-rbinom(1,1,x5)}
    }}
    return(inds)
}

dem_network<-function(inds,x3){
  dist_mat0<-as.matrix(dist.matrix(cbind(inds[,2], inds[,3]),method="euclidean"),diag=T,upper=T) 
  dist_mat1<-as.matrix(dist.matrix(cbind(ifelse(inds[,10]!=Inf,inds[,10],inds[,2]), ifelse(inds[,11]!=Inf,inds[,11],inds[,3])),method="euclidean"),diag=T,upper=T)
  dist_mat2<-as.matrix(dist.matrix(cbind(ifelse(inds[,12]!=Inf,inds[,12],inds[,2]), ifelse(inds[,13]!=Inf,inds[,13],inds[,3])),method="euclidean"),diag=T,upper=T)
  dist_mat3<-as.matrix(dist.matrix(cbind(ifelse(inds[,14]!=Inf,inds[,14],inds[,2]), ifelse(inds[,15]!=Inf,inds[,15],inds[,3])),method="euclidean"),diag=T,upper=T)

  tmp0<-ifelse(dist_mat0<=x3,1,0)
  tmp1<-ifelse(dist_mat1<=x3,1,0)
  tmp2<-ifelse(dist_mat2<=x3,1,0)
  tmp3<-ifelse(dist_mat3<=x3,1,0)

  tmp<-tmp0+tmp1+tmp2+tmp3
  diag(tmp)<-0
  tmp_bin<-ifelse(tmp>0,1,0)
  return(tmp_bin)
}

isi_use<-function(dem_net, inds, k, x6){
   require(igraph)
   g <- graph.adjacency(dem_net)
   sp_mat<-shortest.paths(g)
   alarmed<-which(inds[,1]==1)
   if (length(alarmed)==0) {return(inds)}
   unalarmed<-which(inds[,1]==0)
   if (length(unalarmed)==0) {return(inds)}
   netnew<-matrix(sp_mat[unalarmed,alarmed],ncol=length(alarmed),nrow=length(unalarmed))
   rownames(netnew)<-unalarmed
   colnames(netnew)<-alarmed
   netnew<-ifelse(netnew<=k,netnew, Inf)
   if (x6!=1) {probs<-x6^netnew} else {probs<-ifelse(netnew==Inf,0,1)}
   cum_probs<-rep(NA,nrow(netnew))
   for (i in 1:length(unalarmed)){
       tmp1<-sort(netnew[i,],decreasing=FALSE)
       if(length(tmp1[tmp1==1])>5){
       tmp1<-sample(tmp1[tmp1==1],5)
       } else if(length(tmp1[tmp1==1 | tmp1==2])>5) {
       tmp1<-c(tmp1[tmp1==1],sample(tmp1[tmp1==2],5-length(tmp1[tmp1==1])))
       } else {
       tmp1<-sort(netnew[i,],decreasing=FALSE)[1:5]
       tmp1<-ifelse(tmp1==Inf,0,tmp1)} 
       tmp1<-tmp1[!is.na(names(tmp1))]
       tmp2<-probs[i,names(tmp1)]
       tmp2<-c(tmp2,rep(0,5-length(tmp2)))
       cum_probs[i]<-sum(tmp2)-tmp2[1]*tmp2[2]-tmp2[1]*tmp2[3]-tmp2[1]*tmp2[4]-tmp2[1]*tmp2[5]-tmp2[2]*tmp2[3]-tmp2[2]*tmp2[4]-tmp2[2]*tmp2[5]-tmp2[3]*tmp2[4]-tmp2[3]*tmp2[5]-tmp2[4]*tmp2[5]+tmp2[1]*tmp2[2]*tmp2[3]+tmp2[1]*tmp2[2]*tmp2[4]+tmp2[1]*tmp2[2]*tmp2[5]+tmp2[2]*tmp2[3]*tmp2[4]+tmp2[2]*tmp2[3]*tmp2[5]+tmp2[3]*tmp2[4]*tmp2[5]+tmp2[1]*tmp2[3]*tmp2[4]+tmp2[2]*tmp2[4]*tmp2[5]+tmp2[1]*tmp2[3]*tmp2[5]+tmp2[1]*tmp2[4]*tmp2[5]-tmp2[1]*tmp2[2]*tmp2[3]*tmp2[4]-tmp2[1]*tmp2[2]*tmp2[3]*tmp2[5]-tmp2[1]*tmp2[2]*tmp2[4]*tmp2[5]-tmp2[1]*tmp2[3]*tmp2[4]*tmp2[5]-tmp2[2]*tmp2[3]*tmp2[4]*tmp2[5]+tmp2[1]*tmp2[2]*tmp2[3]*tmp2[4]*tmp2[5]
      }
   for (j in 1:length(cum_probs)){
   inds[unalarmed[j],1]<-rbinom(1,1,cum_probs[j])
   }

   alarmed_prev<-alarmed
   alarmed<-which(inds[,1]==1)
   if (length(alarmed)==0) {return(inds)}
   unalarmed<-which(inds[,1]==0)
   if (length(unalarmed)==0) {return(inds)}
   new_alarmed<-alarmed[! alarmed %in% alarmed_prev]
   netnew<-matrix(sp_mat[unalarmed,new_alarmed],ncol=length(new_alarmed),nrow=length(unalarmed))
   rownames(netnew)<-unalarmed
   colnames(netnew)<-new_alarmed
   netnew<-ifelse(netnew<=k,1,Inf)
   if (x6!=1) {probs<-x6^netnew} else {probs<-ifelse(netnew==Inf,0,1)}
   cum_probs<-rep(NA,nrow(netnew))
   for (i in 1:length(unalarmed)){
       tmp1<-sort(netnew[i,],decreasing=FALSE)
       if(length(tmp1[tmp1==1])>5){
       tmp1<-sample(tmp1[tmp1==1],5)
       } else if(length(tmp1[tmp1==1 | tmp1==2])>5) {
       tmp1<-c(tmp1[tmp1==1],sample(tmp1[tmp1==2],5-length(tmp1[tmp1==1])))
       } else {
       tmp1<-sort(netnew[i,],decreasing=FALSE)[1:5]
       tmp1<-ifelse(tmp1==Inf,0,tmp1)}
       tmp1<-tmp1[!is.na(names(tmp1))]
       tmp2<-probs[i,names(tmp1)]
       tmp2<-c(tmp2,rep(0,5-length(tmp2)))
       cum_probs[i]<-sum(tmp2)-tmp2[1]*tmp2[2]-tmp2[1]*tmp2[3]-tmp2[1]*tmp2[4]-tmp2[1]*tmp2[5]-tmp2[2]*tmp2[3]-tmp2[2]*tmp2[4]-tmp2[2]*tmp2[5]-tmp2[3]*tmp2[4]-tmp2[3]*tmp2[5]-tmp2[4]*tmp2[5]+tmp2[1]*tmp2[2]*tmp2[3]+tmp2[1]*tmp2[2]*tmp2[4]+tmp2[1]*tmp2[2]*tmp2[5]+tmp2[2]*tmp2[3]*tmp2[4]+tmp2[2]*tmp2[3]*tmp2[5]+tmp2[3]*tmp2[4]*tmp2[5]+tmp2[1]*tmp2[3]*tmp2[4]+tmp2[2]*tmp2[4]*tmp2[5]+tmp2[1]*tmp2[3]*tmp2[5]+tmp2[1]*tmp2[4]*tmp2[5]-tmp2[1]*tmp2[2]*tmp2[3]*tmp2[4]-tmp2[1]*tmp2[2]*tmp2[3]*tmp2[5]-tmp2[1]*tmp2[2]*tmp2[4]*tmp2[5]-tmp2[1]*tmp2[3]*tmp2[4]*tmp2[5]-tmp2[2]*tmp2[3]*tmp2[4]*tmp2[5]+tmp2[1]*tmp2[2]*tmp2[3]*tmp2[4]*tmp2[5]
      }
   for (j in 1:length(cum_probs)){
   inds[unalarmed[j],1]<-rbinom(1,1,cum_probs[j])
   }
   return(inds)
}

feeding<-function(inds){
  inds[,6]<-ifelse(inds[,1]==0,inds[,6]+1,inds[,6]+0)
  return(inds)
}

hunt_prey<-function(inds, preds, x4){
    inds_visible<-inds[inds[,1]==0,]
    if(is.null(inds_visible)==T || length(inds_visible)==0) {return(list(inds,preds))} else {
    if(is.null(dim(inds_visible)[1])==TRUE) {inds_visible<-t(inds_visible)}
    hunt_mat<-matrix(0L,nrow=dim(inds_visible)[1],ncol=dim(preds)[1])
    rownames(hunt_mat)<-rownames(inds_visible)
    colnames(hunt_mat)<-rownames(preds)
      for (i in 1:dim(preds)[1]){
          for (j in 1:dim(inds_visible)[1]){
              if(sqrt((preds[i,2]-inds_visible[j,2])^2+(preds[i,3]-inds_visible[j,3])^2)<=x4 & inds_visible[j,5]!=1)  {hunt_mat[j,i]<-1}
              if(sqrt((preds[i,10]-inds_visible[j,2])^2+(preds[i,11]-inds_visible[j,3])^2)<=x4 & inds_visible[j,5]!=1)  {hunt_mat[j,i]<-1}
              if(sqrt((preds[i,12]-inds_visible[j,2])^2+(preds[i,13]-inds_visible[j,3])^2)<=x4 & inds_visible[j,5]!=1)  {hunt_mat[j,i]<-1}
              if(sqrt((preds[i,14]-inds_visible[j,2])^2+(preds[i,15]-inds_visible[j,3])^2)<=x4 & inds_visible[j,5]!=1)  {hunt_mat[j,i]<-1}
              }
      prey<-as.numeric(names(which(hunt_mat[,i]==1)))
      N_prey<-length(prey)
      if(N_prey>0){
      preds[i,6]<-1
      }
      if(N_prey>5){
        prey<-sample(x=prey, size=5, replace=FALSE)
      }
      inds_visible[rownames(inds_visible) %in% prey, 5] <- rbinom(length(prey),1,0.5)
    }
  all_prey<-as.numeric(rownames(inds_visible[inds_visible[,5]==1,]))
  inds[rownames(inds) %in% all_prey,5]<-1
  return(list(inds,preds))}
}

ind_death_birth3<-function(inds, x7, x3){
  total_inds<-dim(inds)[1]
  ind_cols<-dim(inds)[2]
  prosp_par<-inds
  prosp_par[,4]<-ifelse(inds[,6]==0, rpois(n=dim(prosp_par)[1], lambda=x7),rpois(n=dim(prosp_par)[1], lambda=0.75))
  total_off<-sum(prosp_par[, 4])
  new_inds<-array(data=0, dim=c(total_off, ind_cols))
  parents<-prosp_par[prosp_par[,4]!=0,]
  parents<-array(data=parents, dim=c(length(parents)/ind_cols,ind_cols))
  parents<-array(data=parents[rep(seq_len(nrow(parents)), parents[,4]),], dim=c(sum(parents[,4]),ind_cols))
  parents[,4]<-rep(1,nrow(parents))
  new_inds[,2]<-c(parents[,2]+sample(x=c(-10,-9,-8,8,9,10), size=dim(new_inds)[1], replace=TRUE))
  new_inds[,3]<-c(parents[,3]+sample(x=c(-10,-9,-8,8,9,10), size=dim(new_inds)[1], replace=TRUE))
  new_inds[,7]<-x9
  new_inds[,8]<-x3
  orientation<-rep(NA,nrow(new_inds))
  suppressWarnings(for(i in 1:nrow(new_inds)) {orientation[i]<-rwrappedcauchy(1,mu=0,rho=.8)})
  new_inds[,9]<- orientation
  new_inds[,10]<-Inf
  new_inds[,11]<-Inf
  new_inds[,12]<-Inf
  new_inds[,13]<-Inf
  new_inds[,14]<-Inf
  new_inds[,15]<-Inf
  if(!is.array(new_inds) || dim(new_inds)[1]==0){
  inds[,6]<-0
  inds[,4]<-0
  inds[,1]<-0
  inds[,10:15]<-Inf
  return(inds)} else {
  rownames(new_inds)<-as.factor(c(1:nrow(new_inds))+max(as.numeric(rownames(inds))))

  inds<-rbind(inds, new_inds)
  total_inds<-dim(inds)[1]
  for(i in 1:total_inds){
    if(inds[i,2]>spat){
      dist_over<-inds[i,2]-spat
      inds[i,2]<-0+dist_over
    }
    if(inds[i,2]<0){
      dist_over<-inds[i,2]
      inds[i,2]<-spat+dist_over
    }
    if(inds[i,3]>spat){
      dist_over<-inds[i,3]-spat
      inds[i,3]<-0+dist_over
    }
    if(inds[i,3]<0){
      dist_over<-inds[i,3]
      inds[i,3]<-spat+dist_over
    }
  }

  inds[,6]<-0
  inds[,4]<-0
  inds[,1]<-0
  inds[,10:15]<-Inf
  return(inds)}
}

pred_death_birth3<-function(preds, x8, x4){
  total_preds<-dim(preds)[1]
  pred_cols<-dim(preds)[2]
  preds[,4]<-rpois(n=total_preds, lambda=x8)
  total_off<-sum(preds[,4])
  parents<-preds[preds[,4]!=0,]
  new_preds<-array(data=0, dim=c(total_off, pred_cols))
  parents<-array(data=parents, dim=c(length(parents)/pred_cols,pred_cols))
  parents<-array(data=parents[rep(seq_len(nrow(parents)), parents[,4]),], dim=c(sum(parents[,4]),pred_cols))
  parents[,4]<-rep(1,nrow(parents))
  new_preds[,2]<-c(parents[,2]+sample(x=c(-10,-9,-8,8,9,10), size=dim(new_preds)[1], replace=TRUE))
  new_preds[,3]<-c(parents[,3]+sample(x=c(-10,-9,-8,8,9,10), size=dim(new_preds)[1], replace=TRUE))
  new_preds[,7]<-x9
  new_preds[,8]<-x4
  orientation<-rep(NA,nrow(new_preds))
  suppressWarnings(for(i in 1:nrow(new_preds)) {orientation[i]<-rwrappedcauchy(1,mu=0,rho=.8)})
  new_preds[,9]<-orientation

  new_preds[,10]<-Inf
  new_preds[,11]<-Inf
  new_preds[,12]<-Inf    
  new_preds[,13]<-Inf
  new_preds[,14]<-Inf
  new_preds[,15]<-Inf
  if(!is.array(new_preds) || dim(new_preds)[1]==0){
  preds[,6]<-0
  preds[,4]<-0
  preds[,10:15]<-Inf
  return(preds)} else {
  rownames(new_preds)<-as.factor(c(1:nrow(new_preds))+max(as.numeric(rownames(preds))))

  preds<-rbind(preds,new_preds)
  total_preds<-dim(preds)[1]
  for(i in 1:total_preds){
    if(preds[i,2]>spat){
      dist_over<-preds[i,2]-spat
      preds[i,2]<-0+dist_over
    }
    if(preds[i,2]<0){
      dist_over<-preds[i,2]
      preds[i,2]<-spat+dist_over
    }
    if(preds[i,3]>spat){
      dist_over<-preds[i,3]-spat
      preds[i,3]<-0+dist_over
    }
    if(preds[i,3]<0){
      dist_over<-preds[i,3]
      preds[i,3]<-spat+dist_over
    }
  }

  preds[,6]<-0
  preds[,4]<-0
  preds[,10:15]<-Inf
  return(preds)}
}